
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	258
#define	TYPE_NAME	259
#define	LITERAL	260
#define	STRING_LITERAL	261
#define	ELLIPSES	262
#define	MUL_ASSIGN	263
#define	DIV_ASSIGN	264
#define	MOD_ASSIGN	265
#define	ADD_ASSIGN	266
#define	SUB_ASSIGN	267
#define	LEFT_ASSIGN	268
#define	RIGHT_ASSIGN	269
#define	AND_ASSIGN	270
#define	XOR_ASSIGN	271
#define	OR_ASSIGN	272
#define	EQ_OP	273
#define	NE_OP	274
#define	PTR_OP	275
#define	AND_OP	276
#define	OR_OP	277
#define	DEC_OP	278
#define	INC_OP	279
#define	LE_OP	280
#define	GE_OP	281
#define	LEFT_SHIFT	282
#define	RIGHT_SHIFT	283
#define	SIZEOF	284
#define	TYPEDEF	285
#define	EXTERN	286
#define	STATIC	287
#define	AUTO	288
#define	REGISTER	289
#define	CONST	290
#define	VOLATILE	291
#define	VOID	292
#define	INLINE	293
#define	CHAR	294
#define	SHORT	295
#define	INT	296
#define	LONG	297
#define	SIGNED	298
#define	UNSIGNED	299
#define	FLOAT	300
#define	DOUBLE	301
#define	STRUCT	302
#define	UNION	303
#define	ENUM	304
#define	CASE	305
#define	DEFAULT	306
#define	IF	307
#define	ELSE	308
#define	SWITCH	309
#define	WHILE	310
#define	DO	311
#define	FOR	312
#define	GOTO	313
#define	CONTINUE	314
#define	BREAK	315
#define	RETURN	316
#define	ASM	317


/***************************************
  $Header: /home/amb/cxref/RCS/parse.y 1.34 1998/04/18 19:27:12 amb Exp $

  C Cross Referencing & Documentation tool. Version 1.4b.

  C parser.
  ******************/ /******************
  Written by Andrew M. Bishop

  This file Copyright 1995,96,97,98 Andrew M. Bishop
  It may be distributed under the GNU Public License, version 2, or
  any higher version.  See section COPYING of the GNU Public license
  for conditions under which this file may be redistributed.
  ***************************************/

#include <string.h>
#include "parse-yy.h"
#include "cxref.h"
#include "memory.h"

/*+ A structure to hold the information about an object. +*/
typedef struct _stack
{
 char *name;                    /*+ The name of the object. +*/
 char *type;                    /*+ The type of the object. +*/
 char *qual;                    /*+ The type qualifier of the object. +*/
}
stack;

#define yylex cxref_yylex

static int cxref_yylex(void);

static void yyerror(char *s);

/*+ When in a header file, some stuff can be skipped over quickly. +*/
extern int in_header;

/*+ A flag that is set to true when typedef is seen in a statement. +*/
int in_typedef=0;

/*+ The scope of the function / variable that is being examined. +*/
static int scope;

/*+ The variable must be LOCAL or EXTERNAL or GLOBAL, so this checks and sets that. +*/
#define SCOPE ( scope&(LOCAL|EXTERNAL|EXTERN_H|EXTERN_F) ? scope : scope|GLOBAL )

/*+ When in a function or a function definition, the behaviour is different. +*/
static int in_function=0,in_funcdef=0,in_funcbody=0;

/*+ The parsing stack +*/
static stack first={NULL,NULL,NULL},  /*+ first value. +*/
            *list=NULL,               /*+ list of all values. +*/
            *current=&first;          /*+ current values. +*/

/*+ The depth of the stack +*/
static int depth=0,             /*+ currently in use. +*/
           maxdepth=0;          /*+ total malloced. +*/

/*+ Declarations that are in the same statement share this comment. +*/
static char* common_comment=NULL;

/*+ When inside a struct / union / enum definition, this is the depth. +*/
static int in_structunion=0;

/*+ When inside a struct / union definition, this is the component type. +*/
static char *comp_type=NULL;

/*+ To solve the problem where a type name is used as an identifier. +*/
static int in_type_spec=0;


/*++++++++++++++++++++++++++++++++++++++
  Reset the current level on the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void reset(void)
{
 current->name=NULL;
 current->type=NULL;
 current->qual=NULL;
}


/*++++++++++++++++++++++++++++++++++++++
  Push a level onto the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void push(void)
{
 if(list==NULL)
   {
    list=(stack*)Malloc(8*sizeof(struct _stack));
    list[0]=first;
    maxdepth=8;
   }
 else if(depth==maxdepth)
   {
    list=Realloc(list,(maxdepth+8)*sizeof(struct _stack));
    maxdepth+=8;
   }

 depth++;
 current=&list[depth];

 reset();
}


/*++++++++++++++++++++++++++++++++++++++
  Pop a level from the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void pop(void)
{
 reset();

 depth--;
 current=&list[depth];
}


/*++++++++++++++++++++++++++++++++++++++
  Reset the Parser, ready for the next file.
  ++++++++++++++++++++++++++++++++++++++*/

void ResetParser(void)
{
 in_typedef=0;
 scope=0;
 in_function=0;
 in_funcdef=0;
 in_funcbody=0;
 depth=0;
 maxdepth=0;
 if(list) Free(list);
 list=NULL;
 current=&first;
 reset();
 common_comment=NULL;
 in_structunion=0;
 comp_type=NULL;
 in_type_spec=0;
}

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		553
#define	YYFLAG		-32768
#define	YYNTBASE	87

#define YYTRANSLATE(x) ((unsigned)(x) <= 317 ? yytranslate[x] : 255)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    85,     2,     2,     2,    83,    77,     2,    68,
    69,    72,    80,    64,    81,    86,    82,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    73,    63,    78,
    65,    79,    74,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    70,     2,    71,    76,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    66,    75,    67,    84,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     5,     8,    10,    12,    14,    16,    18,
    21,    25,    28,    30,    32,    35,    37,    40,    42,    45,
    47,    48,    53,    55,    57,    60,    63,    67,    70,    72,
    76,    78,    81,    85,    90,    92,    95,    97,   101,   104,
   108,   112,   117,   120,   124,   128,   133,   135,   138,   140,
   143,   146,   150,   152,   156,   158,   160,   162,   166,   167,
   168,   175,   177,   179,   181,   183,   185,   187,   189,   191,
   194,   196,   198,   200,   202,   204,   206,   208,   210,   212,
   214,   216,   218,   221,   224,   226,   229,   232,   234,   236,
   238,   240,   242,   244,   246,   248,   250,   253,   255,   257,
   258,   264,   265,   272,   274,   277,   279,   283,   285,   289,
   291,   294,   296,   298,   300,   302,   303,   309,   310,   317,
   320,   322,   324,   326,   328,   329,   335,   336,   343,   346,
   348,   350,   351,   353,   355,   358,   361,   364,   366,   367,
   372,   373,   379,   380,   386,   388,   392,   394,   396,   398,
   401,   405,   407,   409,   411,   412,   416,   418,   420,   423,
   426,   430,   432,   434,   437,   438,   444,   446,   447,   449,
   451,   453,   457,   459,   463,   465,   469,   472,   474,   477,
   479,   481,   483,   485,   487,   489,   491,   493,   495,   497,
   499,   501,   503,   506,   507,   508,   514,   515,   517,   519,
   522,   524,   526,   528,   536,   542,   544,   546,   548,   556,
   562,   565,   569,   573,   577,   582,   587,   592,   598,   604,
   607,   610,   613,   616,   618,   620,   626,   629,   632,   635,
   639,   641,   644,   648,   650,   652,   656,   658,   660,   664,
   670,   672,   674,   676,   678,   680,   682,   684,   686,   688,
   690,   692,   694,   700,   705,   707,   711,   713,   717,   719,
   723,   725,   729,   731,   735,   737,   741,   743,   745,   747,
   751,   753,   755,   757,   759,   761,   765,   767,   769,   771,
   775,   777,   779,   781,   785,   787,   789,   791,   793,   795,
   797,   799,   801,   803,   805,   807,   809,   811,   813,   816,
   819,   824,   831,   838,   841,   844,   847,   850,   855,   858,
   861,   864,   866,   868,   870,   872,   874,   876,   878,   880,
   882,   886,   890,   894,   899,   903,   908,   911,   914,   919,
   921,   923,   925,   927,   929,   932,   936,   937,   938,   944,
   946,   948,   952,   958,   966,   976,   988,   990,   993,   996,
   997,   999,  1003,  1008,  1009,  1011,  1015,  1020,  1023,  1025,
  1029,  1030,  1032,  1036,  1040,  1046,  1051,  1058,  1060
};

static const short yyrhs[] = {    -1,
    88,     0,    89,     0,    88,    89,     0,    91,     0,   157,
     0,   244,     0,   195,     0,    91,     0,    90,    91,     0,
    92,    94,    63,     0,    92,    63,     0,    93,     0,   111,
     0,   111,    93,     0,   114,     0,   114,    93,     0,   113,
     0,   113,    93,     0,    96,     0,     0,    94,    64,    95,
    96,     0,    97,     0,   103,     0,   103,   249,     0,   103,
    98,     0,   103,   249,    98,     0,    65,   100,     0,   100,
     0,    99,    64,   100,     0,   199,     0,    66,    67,     0,
    66,    99,    67,     0,    66,    99,    64,    67,     0,   104,
     0,   104,   102,     0,   102,     0,    68,   101,    69,     0,
    70,    71,     0,   102,    70,    71,     0,    70,   242,    71,
     0,   102,    70,   242,    71,     0,    68,    69,     0,   102,
    68,    69,     0,    68,   168,    69,     0,   102,    68,   168,
    69,     0,   105,     0,   104,   105,     0,    72,     0,    72,
   112,     0,    72,   104,     0,    72,   112,   104,     0,   106,
     0,    68,   103,    69,     0,   107,     0,   163,     0,     3,
     0,   105,    70,    71,     0,     0,     0,   105,    70,   108,
   242,   109,    71,     0,     3,     0,    33,     0,    31,     0,
    34,     0,    32,     0,    30,     0,    38,     0,   113,     0,
   112,   113,     0,    35,     0,    36,     0,   115,     0,   122,
     0,   116,     0,   117,     0,   132,     0,   119,     0,   138,
     0,   120,     0,    45,     0,    46,     0,    46,    42,     0,
    42,    46,     0,   118,     0,   118,   113,     0,   117,   118,
     0,    43,     0,    44,     0,    39,     0,    40,     0,    41,
     0,    42,     0,     4,     0,    37,     0,    92,     0,    92,
   101,     0,   123,     0,   130,     0,     0,    49,    66,   124,
   126,    67,     0,     0,    49,   131,    66,   125,   126,    67,
     0,   127,     0,   127,    64,     0,   128,     0,   127,    64,
   128,     0,   129,     0,   129,    65,   199,     0,     3,     0,
    49,   131,     0,     3,     0,     4,     0,   133,     0,   136,
     0,     0,    47,    66,   134,   144,    67,     0,     0,    47,
   137,    66,   135,   144,    67,     0,    47,   137,     0,     3,
     0,     4,     0,   139,     0,   142,     0,     0,    48,    66,
   140,   144,    67,     0,     0,    48,   143,    66,   141,   144,
    67,     0,    48,   143,     0,     3,     0,     4,     0,     0,
   145,     0,   146,     0,   145,   146,     0,   133,    63,     0,
   139,    63,     0,   147,     0,     0,   114,   148,   151,    63,
     0,     0,   112,   114,   149,   151,    63,     0,     0,   114,
   112,   150,   151,    63,     0,   152,     0,   151,    64,   152,
     0,   153,     0,   154,     0,   103,     0,    73,   155,     0,
   103,    73,   155,     0,   199,     0,     3,     0,     4,     0,
     0,   159,   158,   173,     0,   160,     0,   161,     0,    92,
   161,     0,   161,    90,     0,    92,   161,    90,     0,   162,
     0,   163,     0,   104,   163,     0,     0,   165,    68,   164,
   166,    69,     0,   105,     0,     0,   168,     0,   167,     0,
     3,     0,   167,    64,     3,     0,   169,     0,   169,    64,
     7,     0,   170,     0,   169,    64,   170,     0,    92,   103,
     0,    92,     0,    92,   101,     0,   244,     0,   173,     0,
   178,     0,   181,     0,   186,     0,   190,     0,   191,     0,
   192,     0,   193,     0,   194,     0,   195,     0,   196,     0,
   171,     0,   172,   171,     0,     0,     0,    66,   174,   176,
   175,    67,     0,     0,   177,     0,   172,     0,   177,   172,
     0,    90,     0,   180,     0,   179,     0,    52,    68,   197,
    69,   171,    53,   171,     0,    52,    68,   197,    69,   171,
     0,   182,     0,   183,     0,   185,     0,    56,   171,    55,
    68,   197,    69,    63,     0,    57,    68,   184,    69,   171,
     0,    63,    63,     0,   197,    63,    63,     0,    63,   197,
    63,     0,    63,    63,   197,     0,    63,   197,    63,   197,
     0,   197,    63,    63,   197,     0,   197,    63,   197,    63,
     0,   197,    63,   197,    63,   197,     0,    55,    68,   197,
    69,   171,     0,   187,    73,     0,   189,    73,     0,   188,
    73,     0,    50,   242,     0,    51,     0,     3,     0,    54,
    68,   197,    69,   171,     0,    60,    63,     0,    59,    63,
     0,   197,    63,     0,    58,     3,    63,     0,    63,     0,
    61,    63,     0,    61,   197,    63,     0,   198,     0,   199,
     0,   198,    64,   199,     0,   201,     0,   250,     0,   217,
   200,   199,     0,   217,   200,    66,   251,    67,     0,    65,
     0,     8,     0,     9,     0,    10,     0,    11,     0,    12,
     0,    13,     0,    14,     0,    15,     0,    16,     0,    17,
     0,   202,     0,   202,    74,   197,    73,   201,     0,   202,
    74,    73,   201,     0,   203,     0,   202,    22,   203,     0,
   204,     0,   203,    21,   204,     0,   205,     0,   204,    75,
   205,     0,   206,     0,   205,    76,   206,     0,   207,     0,
   206,    77,   207,     0,   209,     0,   207,   208,   209,     0,
    18,     0,    19,     0,   211,     0,   209,   210,   211,     0,
    78,     0,    25,     0,    79,     0,    26,     0,   213,     0,
   211,   212,   213,     0,    27,     0,    28,     0,   215,     0,
   213,   214,   215,     0,    80,     0,    81,     0,   217,     0,
   215,   216,   217,     0,    72,     0,    82,     0,    83,     0,
   218,     0,   219,     0,   220,     0,   221,     0,   222,     0,
   223,     0,   224,     0,   225,     0,   226,     0,   227,     0,
   228,     0,    77,   217,     0,    84,   217,     0,    68,   121,
    69,   217,     0,    68,   121,    69,    66,   251,    67,     0,
    68,   121,    69,    66,   254,    67,     0,    72,   217,     0,
    85,   217,     0,    23,   217,     0,    24,   217,     0,    29,
    68,   121,    69,     0,    29,   217,     0,    81,   217,     0,
    80,   217,     0,   229,     0,   232,     0,   233,     0,   234,
     0,   235,     0,   236,     0,   237,     0,   230,     0,   231,
     0,   228,    86,   156,     0,   228,    20,   156,     0,   228,
    68,    69,     0,   228,    68,   243,    69,     0,   110,    68,
    69,     0,   110,    68,   243,    69,     0,   228,    23,     0,
   228,    24,     0,   228,    70,   197,    71,     0,   110,     0,
     5,     0,   238,     0,   239,     0,     6,     0,   238,     6,
     0,    68,   197,    69,     0,     0,     0,    68,   240,   173,
   241,    69,     0,   197,     0,   199,     0,   243,    64,   199,
     0,   245,    68,   238,    69,    63,     0,   245,    68,   238,
    73,   246,    69,    63,     0,   245,    68,   238,    73,   246,
    73,   246,    69,    63,     0,   245,    68,   238,    73,   246,
    73,   246,    73,   248,    69,    63,     0,    62,     0,    62,
    36,     0,    36,    62,     0,     0,   247,     0,   246,    64,
   247,     0,   238,    68,   197,    69,     0,     0,   238,     0,
   248,    64,   238,     0,    62,    68,   238,    69,     0,    21,
   189,     0,   252,     0,   251,    64,   252,     0,     0,   199,
     0,    66,   251,    67,     0,   156,    73,   199,     0,   156,
    73,    66,   251,    67,     0,    86,   156,    65,   199,     0,
    86,   156,    65,    66,   251,    67,     0,   253,     0,   254,
    64,   253,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   169,   170,   174,   175,   179,   181,   183,   184,   190,   192,
   198,   200,   205,   210,   211,   213,   215,   218,   219,   226,
   227,   228,   231,   278,   279,   280,   281,   285,   289,   290,
   294,   295,   296,   297,   304,   305,   307,   311,   314,   316,
   318,   320,   322,   324,   326,   328,   335,   337,   342,   343,
   345,   347,   352,   353,   357,   358,   362,   369,   371,   371,
   372,   378,   382,   384,   389,   391,   393,   397,   402,   403,
   408,   410,   417,   422,   423,   424,   425,   426,   427,   428,
   432,   433,   434,   436,   441,   442,   444,   449,   450,   451,
   452,   453,   454,   458,   462,   466,   468,   475,   476,   480,
   488,   493,   501,   509,   510,   514,   515,   520,   522,   527,
   531,   536,   537,   543,   544,   548,   556,   561,   569,   577,
   582,   583,   589,   590,   594,   602,   607,   615,   623,   628,
   629,   635,   636,   640,   641,   646,   649,   652,   656,   658,
   660,   662,   664,   666,   671,   673,   679,   680,   684,   689,
   691,   696,   700,   701,   709,   712,   716,   738,   739,   741,
   742,   749,   754,   755,   760,   763,   769,   777,   780,   781,
   785,   787,   793,   794,   800,   803,   809,   811,   813,   820,
   821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
   831,   835,   836,   842,   845,   847,   850,   851,   852,   853,
   857,   863,   864,   868,   872,   878,   879,   880,   884,   888,
   892,   893,   894,   895,   896,   897,   898,   899,   903,   909,
   910,   911,   915,   919,   923,   929,   935,   938,   942,   946,
   950,   954,   955,   961,   967,   968,   975,   976,   977,   978,
   981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
   991,   997,   998,  1000,  1007,  1008,  1015,  1016,  1023,  1024,
  1031,  1032,  1039,  1040,  1047,  1048,  1052,  1053,  1059,  1060,
  1064,  1065,  1066,  1067,  1073,  1074,  1078,  1079,  1085,  1086,
  1090,  1091,  1097,  1098,  1102,  1103,  1104,  1110,  1111,  1112,
  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1124,  1128,
  1133,  1135,  1136,  1140,  1144,  1149,  1153,  1157,  1159,  1164,
  1169,  1176,  1177,  1178,  1180,  1181,  1182,  1183,  1187,  1188,
  1192,  1196,  1200,  1201,  1205,  1206,  1210,  1214,  1218,  1222,
  1224,  1225,  1226,  1229,  1230,  1234,  1236,  1236,  1237,  1242,
  1246,  1247,  1255,  1256,  1257,  1258,  1262,  1263,  1264,  1268,
  1269,  1270,  1274,  1278,  1279,  1280,  1284,  1290,  1296,  1297,
  1301,  1302,  1303,  1307,  1308,  1309,  1310,  1314,  1315
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"TYPE_NAME","LITERAL","STRING_LITERAL","ELLIPSES","MUL_ASSIGN","DIV_ASSIGN",
"MOD_ASSIGN","ADD_ASSIGN","SUB_ASSIGN","LEFT_ASSIGN","RIGHT_ASSIGN","AND_ASSIGN",
"XOR_ASSIGN","OR_ASSIGN","EQ_OP","NE_OP","PTR_OP","AND_OP","OR_OP","DEC_OP",
"INC_OP","LE_OP","GE_OP","LEFT_SHIFT","RIGHT_SHIFT","SIZEOF","TYPEDEF","EXTERN",
"STATIC","AUTO","REGISTER","CONST","VOLATILE","VOID","INLINE","CHAR","SHORT",
"INT","LONG","SIGNED","UNSIGNED","FLOAT","DOUBLE","STRUCT","UNION","ENUM","CASE",
"DEFAULT","IF","ELSE","SWITCH","WHILE","DO","FOR","GOTO","CONTINUE","BREAK",
"RETURN","ASM","';'","','","'='","'{'","'}'","'('","')'","'['","']'","'*'","':'",
"'?'","'|'","'^'","'&'","'<'","'>'","'+'","'-'","'/'","'%'","'~'","'!'","'.'",
"file","program","top_level_declaration","declaration_list","declaration","declaration_specifiers",
"declaration_specifiers1","initialized_declarator_list","@1","initialized_declarator",
"initialized_declarator1","initializer_part","initializer_list","initializer",
"abstract_declarator","direct_abstract_declarator","declarator","pointer","direct_declarator",
"simple_declarator","array_declarator","@2","@3","name","storage_class_specifier",
"type_qualifier_list","type_qualifier","type_specifier","type_specifier1","floating_type_specifier",
"integer_type_specifier","integer_type_specifier_part","typedef_name","void_type_specifier",
"type_name","enumeration_type_specifier","enumeration_type_definition","@4",
"@5","enumeration_definition_list","enumeration_definition_list1","enumeration_constant_definition",
"enumeration_constant","enumeration_type_reference","enumeration_tag","structure_type_specifier",
"structure_type_definition","@6","@7","structure_type_reference","structure_tag",
"union_type_specifier","union_type_definition","@8","@9","union_type_reference",
"union_tag","field_list","field_list1","field_list2","component_declaration",
"@10","@11","@12","component_declarator_list","component_declarator","simple_component",
"bit_field","width","component_name","function_definition","@13","function_specifier",
"function_specifier1","function_declarator","function_declarator0","function_direct_declarator",
"@14","function_declarator1","function_declarator2","identifier_list","parameter_type_list",
"parameter_list","parameter_declaration","statement","statement_list","compound_statement",
"@15","@16","compound_statement_body","inner_declaration_list","conditional_statement",
"if_else_statement","if_statement","iterative_statement","do_statement","for_statement",
"for_expressions","while_statement","labeled_statement","case_label","default_label",
"named_label","switch_statement","break_statement","continue_statement","expression_statement",
"goto_statement","null_statement","return_statement","expression","comma_expression",
"assignment_expression","assignment_op","conditional_expression","logical_or_expression",
"logical_and_expression","bitwise_or_expression","bitwise_xor_expression","bitwise_and_expression",
"equality_expression","equality_op","relational_expression","relational_op",
"shift_expression","shift_op","additive_expression","add_op","multiplicative_expression",
"mult_op","unary_expression","address_expression","bitwise_negation_expression",
"cast_expression","indirection_expression","logical_negation_expression","predecrement_expression",
"preincrement_expression","sizeof_expression","unary_minus_expression","unary_plus_expression",
"postfix_expression","component_selection_expression","direct_component_selection",
"indirect_component_selection","function_call","function_call_direct","postdecrement_expression",
"postincrement_expression","subscript_expression","primary_expression","string_literal",
"parenthesized_expression","@17","@18","constant_expression","expression_list",
"asm_statement","asm_type","asm_inout_list","asm_inout","asm_clobber_list","asm_label",
"named_label_address","assignment_expression_list","assignment_expression_list_item",
"named_assignment","named_assignment_list", NULL
};
#endif

static const short yyr1[] = {     0,
    87,    87,    88,    88,    89,    89,    89,    89,    90,    90,
    91,    91,    92,    93,    93,    93,    93,    93,    93,    94,
    95,    94,    96,    97,    97,    97,    97,    98,    99,    99,
   100,   100,   100,   100,   101,   101,   101,   102,   102,   102,
   102,   102,   102,   102,   102,   102,   103,   103,   104,   104,
   104,   104,   105,   105,   105,   105,   106,   107,   108,   109,
   107,   110,   111,   111,   111,   111,   111,   111,   112,   112,
   113,   113,   114,   115,   115,   115,   115,   115,   115,   115,
   116,   116,   116,   116,   117,   117,   117,   118,   118,   118,
   118,   118,   118,   119,   120,   121,   121,   122,   122,   124,
   123,   125,   123,   126,   126,   127,   127,   128,   128,   129,
   130,   131,   131,   132,   132,   134,   133,   135,   133,   136,
   137,   137,   138,   138,   140,   139,   141,   139,   142,   143,
   143,   144,   144,   145,   145,   146,   146,   146,   148,   147,
   149,   147,   150,   147,   151,   151,   152,   152,   153,   154,
   154,   155,   156,   156,   158,   157,   159,   160,   160,   160,
   160,   161,   162,   162,   164,   163,   165,   166,   166,   166,
   167,   167,   168,   168,   169,   169,   170,   170,   170,   171,
   171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
   171,   172,   172,   174,   175,   173,   176,   176,   176,   176,
   177,   178,   178,   179,   180,   181,   181,   181,   182,   183,
   184,   184,   184,   184,   184,   184,   184,   184,   185,   186,
   186,   186,   187,   188,   189,   190,   191,   192,   193,   194,
   195,   196,   196,   197,   198,   198,   199,   199,   199,   199,
   200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
   200,   201,   201,   201,   202,   202,   203,   203,   204,   204,
   205,   205,   206,   206,   207,   207,   208,   208,   209,   209,
   210,   210,   210,   210,   211,   211,   212,   212,   213,   213,
   214,   214,   215,   215,   216,   216,   216,   217,   217,   217,
   217,   217,   217,   217,   217,   217,   217,   217,   218,   219,
   220,   220,   220,   221,   222,   223,   224,   225,   225,   226,
   227,   228,   228,   228,   228,   228,   228,   228,   229,   229,
   230,   231,   232,   232,   233,   233,   234,   235,   236,   237,
   237,   237,   237,   238,   238,   239,   240,   241,   239,   242,
   243,   243,   244,   244,   244,   244,   245,   245,   245,   246,
   246,   246,   247,   248,   248,   248,   249,   250,   251,   251,
   252,   252,   252,   253,   253,   253,   253,   254,   254
};

static const short yyr2[] = {     0,
     0,     1,     1,     2,     1,     1,     1,     1,     1,     2,
     3,     2,     1,     1,     2,     1,     2,     1,     2,     1,
     0,     4,     1,     1,     2,     2,     3,     2,     1,     3,
     1,     2,     3,     4,     1,     2,     1,     3,     2,     3,
     3,     4,     2,     3,     3,     4,     1,     2,     1,     2,
     2,     3,     1,     3,     1,     1,     1,     3,     0,     0,
     6,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     2,     1,     1,     0,
     5,     0,     6,     1,     2,     1,     3,     1,     3,     1,
     2,     1,     1,     1,     1,     0,     5,     0,     6,     2,
     1,     1,     1,     1,     0,     5,     0,     6,     2,     1,
     1,     0,     1,     1,     2,     2,     2,     1,     0,     4,
     0,     5,     0,     5,     1,     3,     1,     1,     1,     2,
     3,     1,     1,     1,     0,     3,     1,     1,     2,     2,
     3,     1,     1,     2,     0,     5,     1,     0,     1,     1,
     1,     3,     1,     3,     1,     3,     2,     1,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     2,     0,     0,     5,     0,     1,     1,     2,
     1,     1,     1,     7,     5,     1,     1,     1,     7,     5,
     2,     3,     3,     3,     4,     4,     4,     5,     5,     2,
     2,     2,     2,     1,     1,     5,     2,     2,     2,     3,
     1,     2,     3,     1,     1,     3,     1,     1,     3,     5,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     5,     4,     1,     3,     1,     3,     1,     3,
     1,     3,     1,     3,     1,     3,     1,     1,     1,     3,
     1,     1,     1,     1,     1,     3,     1,     1,     1,     3,
     1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
     4,     6,     6,     2,     2,     2,     2,     4,     2,     2,
     2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     3,     3,     3,     4,     3,     4,     2,     2,     4,     1,
     1,     1,     1,     1,     2,     3,     0,     0,     5,     1,
     1,     3,     5,     7,     9,    11,     1,     2,     2,     0,
     1,     3,     4,     0,     1,     3,     4,     2,     1,     3,
     0,     1,     3,     3,     5,     4,     6,     1,     3
};

static const short yydefact[] = {     1,
    57,    94,    67,    64,    66,    63,    65,    71,    72,    95,
    68,    90,    91,    92,    93,    88,    89,    81,    82,     0,
     0,     0,   347,   231,     0,    49,     2,     3,     5,     0,
    13,     0,   167,    53,    55,    14,    18,    16,    73,    75,
    76,    85,    78,    80,    74,    98,    99,    77,   114,   115,
    79,   123,   124,     6,   155,   157,   158,   162,   163,     0,
     8,     7,     0,   349,    84,    83,   121,   122,   116,   120,
   130,   131,   125,   129,   112,   113,   100,   111,   348,     0,
     0,    47,    56,    72,    51,    50,    69,     4,    12,     0,
    20,    23,    24,     0,   159,   164,    59,    15,    19,    17,
    93,    87,    86,     0,   160,     9,     0,   165,     0,   132,
   118,   132,   127,     0,   102,    54,    48,    52,    70,    11,
    21,     0,     0,    26,    25,   161,    58,     0,   194,   156,
    10,   168,   334,     0,     0,   139,   114,   123,     0,   133,
   134,   138,   132,     0,   132,   110,     0,   104,   106,   108,
     0,     0,     0,    62,   331,     0,     0,     0,     0,     0,
   337,     0,     0,     0,     0,     0,     0,    28,   330,    31,
   237,   252,   255,   257,   259,   261,   263,   265,   269,   275,
   279,   283,   288,   289,   290,   291,   292,   293,   294,   295,
   296,   297,   298,   312,   319,   320,   313,   314,   315,   316,
   317,   318,   332,   333,   238,    27,   340,   234,   235,    60,
   197,   171,   178,     0,   170,   169,   173,   175,   335,     0,
   350,   141,   143,     0,   136,   137,   117,   135,     0,   126,
     0,   101,   105,     0,     0,    22,     0,   225,   358,   306,
   307,   337,   309,    32,     0,    29,    96,     0,     0,     0,
   304,   299,   311,   310,   300,   305,     0,     0,     0,     0,
     0,     0,     0,   267,   268,     0,   272,   274,   271,   273,
     0,   277,   278,     0,   281,   282,     0,   285,   286,   287,
     0,   242,   243,   244,   245,   246,   247,   248,   249,   250,
   251,   241,     0,     0,   327,   328,     0,     0,     0,     0,
     0,    62,     0,   224,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   201,   192,   199,   181,   195,   198,   182,
   203,   202,   183,   206,   207,   208,   184,     0,     0,     0,
   185,   186,   187,   188,   189,   190,   191,     0,   180,     0,
     0,   179,    37,   177,    35,   166,     0,     0,   343,     0,
     0,   351,     0,     0,     0,   149,     0,   145,   147,   148,
   119,   128,   107,   109,   103,   357,     0,     0,    33,     0,
    97,    35,     0,   336,   338,   325,   341,     0,   256,   283,
     0,     0,   258,   260,   262,   264,   266,   270,   276,   280,
   284,   361,   239,   153,   154,   322,   323,     0,     0,   321,
   236,    61,   223,     0,     0,     0,     0,     0,     0,     0,
   228,   227,   232,     0,   193,     0,   200,   220,   222,   221,
   229,    43,     0,     0,    39,     0,     0,     0,    36,   172,
   174,   176,     0,     0,     0,   350,     0,     0,   150,   152,
     0,   140,     0,   308,    34,    30,   361,   301,     0,     0,
   326,   254,     0,   361,   362,     0,   359,   324,   329,     0,
     0,     0,     0,     0,     0,     0,   230,   233,   196,    38,
    45,    41,    44,     0,    40,     0,     0,   352,   344,     0,
   142,   144,   151,   146,    62,     0,     0,     0,   368,     0,
   339,   342,   253,     0,   361,   240,     0,     0,     0,     0,
   211,     0,     0,     0,    46,    42,   353,     0,   354,     0,
     0,   302,     0,   303,   363,   360,   205,   226,   219,     0,
   214,   213,   210,   212,     0,   345,   355,     0,     0,   361,
   364,   369,     0,     0,   215,   216,   217,     0,     0,   361,
   366,     0,   204,   209,   218,   356,   346,     0,   365,   367,
     0,     0,     0
};

static const short yydefgoto[] = {   551,
    27,    28,   105,   106,   107,    31,    90,   152,    91,    92,
   124,   245,   168,   423,   343,   356,    81,    82,    34,    35,
   128,   301,   169,    36,   135,    37,    38,    39,    40,    41,
    42,    43,    44,   248,    45,    46,   114,   151,   147,   148,
   149,   150,    47,    78,    48,    49,   110,   143,    50,    70,
    51,    52,   112,   145,    53,    74,   139,   140,   141,   142,
   224,   353,   354,   357,   358,   359,   360,   439,   487,    54,
   104,    55,    56,    57,    58,    83,   132,    60,   214,   215,
   424,   217,   218,   315,   316,   317,   211,   416,   318,   319,
   320,   321,   322,   323,   324,   325,   465,   326,   327,   328,
   329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
   208,   209,   293,   171,   172,   173,   174,   175,   176,   177,
   266,   178,   271,   179,   274,   180,   277,   181,   281,   182,
   183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
   193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
   203,   204,   250,   449,   210,   378,   339,    63,   351,   352,
   528,   125,   205,   456,   457,   489,   490
};

static const short yypact[] = {  1150,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -30,-32768,
-32768,-32768,-32768,-32768,    24,-32768,-32768,-32768,    79,    43,
    58,    63,    29,-32768,    73,   113,  1150,-32768,-32768,    35,
-32768,    60,    12,-32768,-32768,  1404,  1404,  1404,-32768,-32768,
   315,   205,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  1404,-32768,   280,    17,
-32768,-32768,    20,-32768,-32768,-32768,-32768,-32768,-32768,    34,
-32768,-32768,-32768,    91,-32768,-32768,-32768,   109,-32768,   112,
    60,    74,-32768,-32768,-32768,   113,-32768,-32768,-32768,   133,
-32768,-32768,     9,    60,  1404,   280,   115,-32768,-32768,-32768,
-32768,-32768,-32768,   164,  1404,-32768,    35,-32768,   242,  1215,
-32768,  1215,-32768,   208,-32768,-32768,    74,-32768,-32768,-32768,
-32768,   183,   621,-32768,   213,  1404,-32768,  1050,-32768,-32768,
-32768,  1338,-32768,    21,  1215,   205,   210,   223,   230,  1215,
-32768,-32768,  1215,   232,  1215,-32768,   237,   227,-32768,   273,
   208,    73,   242,-32768,-32768,   329,  1075,  1075,  1143,   589,
   471,  1075,  1075,  1075,  1075,  1075,  1075,-32768,   268,-32768,
-32768,    32,   319,   285,   286,   284,   240,     5,   255,   215,
    -4,   301,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   123,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   357,-32768,-32768,-32768,-32768,   300,-32768,-32768,
   401,-32768,    46,   296,   303,-32768,   304,-32768,-32768,   306,
   242,-32768,   205,    23,-32768,-32768,-32768,-32768,   305,-32768,
   311,-32768,   208,  1050,   313,-32768,    18,-32768,-32768,-32768,
-32768,   471,-32768,-32768,   116,-32768,   161,   312,   314,   164,
-32768,-32768,-32768,-32768,-32768,-32768,   184,  1075,   694,  1075,
  1075,  1075,  1075,-32768,-32768,  1075,-32768,-32768,-32768,-32768,
  1075,-32768,-32768,  1075,-32768,-32768,  1075,-32768,-32768,-32768,
  1075,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   704,   318,-32768,-32768,   726,  1050,   318,  1050,
   299,   309,  1050,-32768,   316,   317,   320,   521,   321,   370,
   323,   324,   736,  1404,-32768,   521,-32768,-32768,   521,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   322,   325,   328,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   330,-32768,  1199,
   809,-32768,    98,-32768,    40,-32768,   388,  1358,-32768,    36,
   130,-32768,    23,    23,  1050,   337,   260,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   327,   611,-32768,  1245,
-32768,   224,  1060,-32768,-32768,-32768,-32768,     0,   319,-32768,
  1075,   338,   285,   286,   284,   240,     5,   255,   215,    -4,
-32768,   819,-32768,-32768,-32768,-32768,-32768,    94,   331,-32768,
-32768,-32768,-32768,  1050,  1050,  1050,   -30,   339,   844,   340,
-32768,-32768,-32768,   350,-32768,   347,   521,-32768,-32768,-32768,
-32768,-32768,   346,   348,-32768,   345,  1291,   855,    98,-32768,
-32768,-32768,  1050,   242,   355,   242,   267,   271,-32768,-32768,
  1050,-32768,    23,  1060,-32768,-32768,   221,-32768,   351,  1050,
-32768,-32768,  1075,   819,-32768,   131,-32768,-32768,-32768,   352,
   354,   358,   386,   928,   396,   363,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   397,-32768,   399,   402,-32768,-32768,   159,
-32768,-32768,-32768,-32768,   395,   318,   406,   154,-32768,   155,
-32768,-32768,-32768,   171,   819,-32768,   521,   521,   521,  1050,
  1050,   409,   521,   938,-32768,-32768,-32768,   417,   242,   418,
   960,-32768,    19,-32768,-32768,-32768,   431,-32768,-32768,   419,
-32768,  1050,-32768,  1050,   424,-32768,   357,    96,  1028,   819,
-32768,-32768,   521,   426,-32768,-32768,  1050,   242,   427,   819,
-32768,   182,-32768,-32768,-32768,   357,-32768,   196,-32768,-32768,
   392,   491,-32768
};

static const short yypgoto[] = {-32768,
-32768,   466,   -74,    14,     1,   239,-32768,-32768,   344,-32768,
   372,-32768,  -154,  -132,  -292,   -21,     7,     8,-32768,-32768,
-32768,-32768,-32768,-32768,   -10,   -13,   127,-32768,-32768,-32768,
   457,-32768,-32768,   257,-32768,-32768,-32768,-32768,   371,-32768,
   288,-32768,-32768,-32768,-32768,    72,-32768,-32768,-32768,-32768,
-32768,   145,-32768,-32768,-32768,-32768,    26,-32768,   383,-32768,
-32768,-32768,-32768,    -2,    82,-32768,-32768,    87,  -282,-32768,
-32768,-32768,-32768,   499,-32768,    45,-32768,-32768,-32768,-32768,
  -127,-32768,   185,  -297,   211,   -89,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   375,-32768,-32768,-32768,-32768,-32768,   125,-32768,  -125,
-32768,  -121,-32768,  -361,-32768,   274,   275,   276,   272,   277,
-32768,   270,-32768,   278,-32768,   264,-32768,   269,-32768,  -107,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -109,-32768,-32768,-32768,  -293,   244,   150,-32768,   111,   119,
-32768,-32768,-32768,  -429,    59,    47,-32768
};


#define	YYLAST		1453


static const short yytable[] = {   134,
    30,   170,   207,    80,   216,   246,    32,    33,    93,   403,
   408,   396,    87,    29,   130,    86,   400,   488,   415,   452,
   126,   394,   395,   219,   494,     1,   219,    30,   103,   267,
   268,    64,    85,    32,    33,   249,    94,     1,   170,    33,
    29,   219,     1,   237,    59,    67,    68,   426,     1,   240,
   241,   243,   429,   258,   251,   252,   253,   254,   255,   256,
    71,    72,     1,   450,    79,    75,    76,   278,   451,    65,
   122,    59,   119,   123,    59,     1,    96,   279,   280,   429,
   342,    97,   269,   270,   108,    93,   366,   109,   117,   220,
    25,   493,   118,   221,    26,   355,    87,    89,    87,   111,
   542,   117,    25,   433,   486,   259,    26,   340,    69,   341,
   548,   350,   364,   340,   371,   341,   249,    26,   131,   415,
    66,   119,    87,    73,    61,   223,    87,    25,    77,    87,
    93,    87,   213,   382,   476,   377,   314,   144,    96,   131,
    25,  -167,   294,    97,    26,   295,   296,     8,    84,    62,
   380,    61,   380,   380,   380,   380,   113,   450,   380,   538,
   375,   247,   458,   380,   539,   427,   380,   428,   229,   380,
   231,   393,   399,   391,   115,   377,    62,   207,   401,   368,
   116,   137,   369,   137,    26,   127,   154,   414,   155,   133,
   297,   344,   298,   434,   495,   120,   121,   496,   435,   517,
   518,   519,   436,   510,   156,   523,   157,   158,   299,   119,
   146,   137,   159,   446,   137,   207,   137,   495,   513,   345,
   512,   514,   434,   485,   395,   155,   133,   508,   370,   129,
   341,   509,    26,   440,   495,   543,   136,   515,   136,     8,
    84,   156,   247,   157,   158,   495,   170,   133,   549,   159,
   153,   161,   376,   372,   138,   162,   138,   264,   265,   495,
   163,   222,   550,   164,   165,   448,   136,   166,   167,   136,
   455,   136,   225,   380,    98,    99,   100,   123,   460,   461,
   462,   272,   273,   466,   138,   226,   454,   138,   161,   138,
   233,   370,   162,   341,   275,   276,   227,   163,   230,   474,
   164,   165,   207,   232,   166,   167,   486,   477,   282,   283,
   284,   285,   286,   287,   288,   289,   290,   291,    80,   440,
   394,   395,   442,   443,   350,   455,   350,   131,   492,   481,
   443,   238,   455,   482,   443,   257,   448,   234,   502,   260,
   213,   -56,   -56,   -56,   -56,   380,   345,   -56,   213,   -56,
   437,   438,   117,    12,    13,    14,   101,    16,    17,   261,
   263,   262,   219,   300,   346,   292,   347,   348,   349,   402,
   213,   361,   410,   455,   520,   521,   372,   362,   525,   365,
   373,  -225,   374,   404,   405,   411,   412,   406,   409,   531,
   430,   552,   421,   463,   418,   444,   535,   419,   536,   527,
   420,   459,   467,   302,     2,   155,   133,   541,   455,   441,
   453,   545,   468,   469,   470,   472,   471,   479,   455,   491,
   497,   156,   498,   157,   158,   504,   499,   213,   546,   159,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
   303,   304,   305,   500,   306,   307,   308,   309,   310,   311,
   312,   313,    23,    24,   503,   505,   129,  -153,   161,   506,
   507,   522,   162,   154,     2,   155,   133,   163,   511,   526,
   164,   165,   529,   533,   166,   167,   537,   534,   544,   547,
   553,   156,    88,   157,   158,   236,   206,   102,   367,   159,
     3,     4,     5,     6,     7,     8,    84,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
   363,   235,   228,   302,   484,   155,   133,   483,    95,   417,
   239,   379,   432,   385,   383,   387,   384,   389,   161,   386,
   398,   156,   162,   157,   158,   390,   480,   163,   388,   159,
   164,   165,   478,   516,   166,   167,   407,     0,     0,   532,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   303,   304,   305,     0,   306,   307,   308,   309,   310,   311,
   312,   313,    23,    24,     0,     0,   129,     0,   161,     0,
     0,   154,   162,   155,   133,     0,     0,   163,     0,     0,
   164,   165,     0,     0,   166,   167,     0,     0,     0,   156,
     0,   157,   158,   154,     0,   155,   133,   159,     0,     0,
     0,     0,     0,   154,     0,   155,   133,     0,     0,     0,
     0,   156,     0,   157,   158,     0,     0,     0,     0,   159,
     0,   156,     0,   157,   158,     0,     0,     0,     0,   159,
     0,     0,     0,     0,   160,   244,   161,     0,     0,     0,
   162,     0,     0,     0,     0,   163,     0,     0,   164,   165,
     0,     0,   166,   167,     0,     0,   160,   445,   161,     0,
     0,     0,   162,     0,     0,     0,   160,   163,   161,     0,
   164,   165,   162,     0,   166,   167,   154,   163,   155,   133,
   164,   165,     0,     0,   166,   167,   154,     0,   155,   133,
     0,     0,     0,     0,   156,     0,   157,   158,     0,     0,
     0,     0,   159,     0,   156,     0,   157,   158,   154,     0,
   155,   133,   159,     0,     0,     0,     0,     0,   154,     0,
   155,   133,     0,     0,     0,     0,   156,     0,   157,   158,
     0,     0,     0,     0,   159,     0,   156,     0,   157,   158,
     0,   161,     0,     0,   159,   162,   381,     0,     0,   392,
   163,   161,     0,   164,   165,   162,     0,   166,   167,     0,
   163,     0,     0,   164,   165,     0,     0,   166,   167,     0,
     0,     0,     0,   161,   397,     0,     0,   162,   413,     0,
     0,     0,   163,   161,     0,   164,   165,   162,     0,   166,
   167,   154,   163,   155,   133,   164,   165,     0,     0,   166,
   167,   154,     0,   155,   133,     0,     0,     0,     0,   156,
     0,   157,   158,     0,     0,     0,     0,   159,     0,   156,
     0,   157,   158,     0,     0,     0,   154,   159,   155,   133,
     0,     0,     0,     0,     0,     0,     0,   154,     0,   155,
   133,     0,     0,     0,   156,     0,   157,   158,     0,     0,
     0,     0,   159,     0,     0,   156,   161,   157,   158,   425,
   162,     0,     0,   159,   454,   163,   161,     0,   164,   165,
   162,     0,   166,   167,     0,   163,     0,     0,   164,   165,
     0,     0,   166,   167,     0,     0,   464,     0,     0,     0,
     0,   161,     0,     0,     0,   162,     0,     0,     0,     0,
   163,     0,   161,   164,   165,   475,   162,   166,   167,     0,
   154,   163,   155,   133,   164,   165,     0,     0,   166,   167,
   154,     0,   155,   133,     0,     0,     0,     0,   156,     0,
   157,   158,     0,     0,     0,     0,   159,     0,   156,     0,
   157,   158,   154,     0,   155,   133,   159,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   156,     0,   157,   158,     0,     0,     0,     0,   159,     0,
   501,     0,     0,     0,     0,   161,     0,     0,     0,   162,
   524,     0,     0,     0,   163,   161,     0,   164,   165,   162,
     0,   166,   167,     0,   163,     0,     0,   164,   165,     0,
     0,   166,   167,     0,     0,   530,     0,   161,     0,     0,
   154,   162,   155,   133,     0,     0,   163,     0,     0,   164,
   165,     0,     0,   166,   167,     0,     0,     0,   156,     0,
   157,   158,   154,     0,   155,   133,   159,     0,     0,     0,
     0,     0,   154,     0,   155,   133,     0,     0,     0,     0,
   156,     0,   157,   158,     0,     0,     0,   154,   159,   155,
   133,     0,   157,   158,     0,     0,     0,     0,   159,     0,
     0,     0,     0,   540,     0,   161,     0,   157,   158,   162,
     0,     0,     0,   159,   163,     0,     0,   164,   165,     0,
     0,   166,   167,     0,     0,     0,     0,   161,     0,     0,
     0,   162,     0,     0,     0,   447,   163,   161,     0,   164,
   165,   162,     0,   166,   167,     0,   163,     0,     0,   164,
   165,     0,   161,   166,   167,   154,   162,   155,   133,     0,
     0,   163,     1,     2,   164,   165,     0,     0,   166,   167,
     0,     0,     0,     0,     0,   157,   158,     0,     0,     0,
     0,   159,     0,     0,     0,     0,     0,     0,     0,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,     0,
     0,     1,     2,     0,     0,     0,     0,     0,     0,     0,
   242,    23,    24,     0,   162,     0,     0,    25,     2,   163,
     0,    26,   164,   165,     0,     0,   166,   167,     3,     4,
     5,     6,     7,     8,    84,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,     2,     8,
    84,    10,     0,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,     0,     0,   340,   422,   341,     0,
    26,     0,     0,     0,     3,     4,     5,     6,     7,     8,
    84,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,     2,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   370,   422,   341,     0,    26,     0,     0,     0,
     3,     4,     5,     6,     7,     8,    84,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
   212,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   473,
     0,     2,     0,     0,   431,     0,     0,     3,     4,     5,
     6,     7,     8,    84,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,     3,     4,     5,
     6,     7,     8,    84,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,     2,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     3,     4,     5,     6,     7,     8,    84,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22
};

static const short yycheck[] = {   109,
     0,   123,   128,    25,   132,   160,     0,     0,    30,   303,
   308,   294,    26,     0,   104,    26,   299,   447,   316,   381,
    95,     3,     4,     6,   454,     3,     6,    27,    42,    25,
    26,    62,    26,    27,    27,   161,    30,     3,   160,    32,
    27,     6,     3,   153,     0,     3,     4,   341,     3,   157,
   158,   159,   345,    22,   162,   163,   164,   165,   166,   167,
     3,     4,     3,    64,    36,     3,     4,    72,    69,    46,
    62,    27,    86,    65,    30,     3,    32,    82,    83,   372,
   213,    70,    78,    79,    68,   107,    69,    68,    81,    69,
    68,   453,    86,    73,    72,    73,   110,    63,   112,    66,
   530,    94,    68,    68,    86,    74,    72,    68,    66,    70,
   540,   221,   234,    68,   247,    70,   242,    72,   105,   417,
    42,   135,   136,    66,     0,   136,   140,    68,    66,   143,
   152,   145,   132,   259,   428,   257,   211,   112,    94,   126,
    68,    68,    20,    70,    72,    23,    24,    35,    36,     0,
   258,    27,   260,   261,   262,   263,    66,    64,   266,    64,
   250,   161,    69,   271,    69,    68,   274,    70,   143,   277,
   145,   293,   298,   281,    66,   297,    27,   303,   300,    64,
    69,   110,    67,   112,    72,    71,     3,   313,     5,     6,
    68,   213,    70,    64,    64,    63,    64,    67,    69,   497,
   498,   499,    73,   486,    21,   503,    23,    24,    86,   223,
     3,   140,    29,   368,   143,   341,   145,    64,    64,   213,
    67,    67,    64,     3,     4,     5,     6,    69,    68,    66,
    70,    73,    72,   355,    64,   533,   110,    67,   112,    35,
    36,    21,   242,    23,    24,    64,   368,     6,    67,    29,
    68,    68,    69,   247,   110,    72,   112,    18,    19,    64,
    77,   135,    67,    80,    81,   373,   140,    84,    85,   143,
   392,   145,    63,   381,    36,    37,    38,    65,   404,   405,
   406,    27,    28,   409,   140,    63,    66,   143,    68,   145,
    64,    68,    72,    70,    80,    81,    67,    77,    67,   427,
    80,    81,   428,    67,    84,    85,    86,   433,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,   340,   441,
     3,     4,    63,    64,   434,   447,   436,   314,   450,    63,
    64,     3,   454,    63,    64,    68,   444,    65,   464,    21,
   340,    62,    63,    64,    65,   453,   340,    68,   348,    70,
   353,   354,   345,    39,    40,    41,    42,    43,    44,    75,
    77,    76,     6,    64,    69,    65,    64,    64,    63,    71,
   370,    67,     3,   495,   500,   501,   370,    67,   504,    67,
    69,    73,    69,    68,    68,    63,    63,    68,    68,   511,
     3,     0,    63,    55,    73,    69,   522,    73,   524,   509,
    73,    71,    63,     3,     4,     5,     6,   529,   530,    73,
    73,   537,    63,    67,    69,    71,    69,    63,   540,    69,
    69,    21,    69,    23,    24,    63,    69,   427,   538,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    68,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    69,    69,    66,    73,    68,    71,
    69,    63,    72,     3,     4,     5,     6,    77,    73,    63,
    80,    81,    65,    53,    84,    85,    63,    69,    63,    63,
     0,    21,    27,    23,    24,   152,   125,    41,   242,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
   233,   151,   140,     3,   443,     5,     6,   441,    30,   319,
   156,   258,   348,   262,   260,   266,   261,   274,    68,   263,
   297,    21,    72,    23,    24,   277,   436,    77,   271,    29,
    80,    81,   434,   495,    84,    85,    36,    -1,    -1,   513,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    50,    51,    52,    -1,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    -1,    -1,    66,    -1,    68,    -1,
    -1,     3,    72,     5,     6,    -1,    -1,    77,    -1,    -1,
    80,    81,    -1,    -1,    84,    85,    -1,    -1,    -1,    21,
    -1,    23,    24,     3,    -1,     5,     6,    29,    -1,    -1,
    -1,    -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,
    -1,    21,    -1,    23,    24,    -1,    -1,    -1,    -1,    29,
    -1,    21,    -1,    23,    24,    -1,    -1,    -1,    -1,    29,
    -1,    -1,    -1,    -1,    66,    67,    68,    -1,    -1,    -1,
    72,    -1,    -1,    -1,    -1,    77,    -1,    -1,    80,    81,
    -1,    -1,    84,    85,    -1,    -1,    66,    67,    68,    -1,
    -1,    -1,    72,    -1,    -1,    -1,    66,    77,    68,    -1,
    80,    81,    72,    -1,    84,    85,     3,    77,     5,     6,
    80,    81,    -1,    -1,    84,    85,     3,    -1,     5,     6,
    -1,    -1,    -1,    -1,    21,    -1,    23,    24,    -1,    -1,
    -1,    -1,    29,    -1,    21,    -1,    23,    24,     3,    -1,
     5,     6,    29,    -1,    -1,    -1,    -1,    -1,     3,    -1,
     5,     6,    -1,    -1,    -1,    -1,    21,    -1,    23,    24,
    -1,    -1,    -1,    -1,    29,    -1,    21,    -1,    23,    24,
    -1,    68,    -1,    -1,    29,    72,    73,    -1,    -1,    66,
    77,    68,    -1,    80,    81,    72,    -1,    84,    85,    -1,
    77,    -1,    -1,    80,    81,    -1,    -1,    84,    85,    -1,
    -1,    -1,    -1,    68,    69,    -1,    -1,    72,    63,    -1,
    -1,    -1,    77,    68,    -1,    80,    81,    72,    -1,    84,
    85,     3,    77,     5,     6,    80,    81,    -1,    -1,    84,
    85,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    21,
    -1,    23,    24,    -1,    -1,    -1,    -1,    29,    -1,    21,
    -1,    23,    24,    -1,    -1,    -1,     3,    29,     5,     6,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,
     6,    -1,    -1,    -1,    21,    -1,    23,    24,    -1,    -1,
    -1,    -1,    29,    -1,    -1,    21,    68,    23,    24,    71,
    72,    -1,    -1,    29,    66,    77,    68,    -1,    80,    81,
    72,    -1,    84,    85,    -1,    77,    -1,    -1,    80,    81,
    -1,    -1,    84,    85,    -1,    -1,    63,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
    77,    -1,    68,    80,    81,    71,    72,    84,    85,    -1,
     3,    77,     5,     6,    80,    81,    -1,    -1,    84,    85,
     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    21,    -1,
    23,    24,    -1,    -1,    -1,    -1,    29,    -1,    21,    -1,
    23,    24,     3,    -1,     5,     6,    29,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    21,    -1,    23,    24,    -1,    -1,    -1,    -1,    29,    -1,
    63,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    72,
    63,    -1,    -1,    -1,    77,    68,    -1,    80,    81,    72,
    -1,    84,    85,    -1,    77,    -1,    -1,    80,    81,    -1,
    -1,    84,    85,    -1,    -1,    66,    -1,    68,    -1,    -1,
     3,    72,     5,     6,    -1,    -1,    77,    -1,    -1,    80,
    81,    -1,    -1,    84,    85,    -1,    -1,    -1,    21,    -1,
    23,    24,     3,    -1,     5,     6,    29,    -1,    -1,    -1,
    -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
    21,    -1,    23,    24,    -1,    -1,    -1,     3,    29,     5,
     6,    -1,    23,    24,    -1,    -1,    -1,    -1,    29,    -1,
    -1,    -1,    -1,    66,    -1,    68,    -1,    23,    24,    72,
    -1,    -1,    -1,    29,    77,    -1,    -1,    80,    81,    -1,
    -1,    84,    85,    -1,    -1,    -1,    -1,    68,    -1,    -1,
    -1,    72,    -1,    -1,    -1,    66,    77,    68,    -1,    80,
    81,    72,    -1,    84,    85,    -1,    77,    -1,    -1,    80,
    81,    -1,    68,    84,    85,     3,    72,     5,     6,    -1,
    -1,    77,     3,     4,    80,    81,    -1,    -1,    84,    85,
    -1,    -1,    -1,    -1,    -1,    23,    24,    -1,    -1,    -1,
    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    -1,
    -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    68,    62,    63,    -1,    72,    -1,    -1,    68,     4,    77,
    -1,    72,    80,    81,    -1,    -1,    84,    85,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,     4,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    -1,    -1,    68,    69,    70,    -1,
    72,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,     4,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    68,    69,    70,    -1,    72,    -1,    -1,    -1,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
    -1,     4,    -1,    -1,     7,    -1,    -1,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,     4,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
{ scope=0; reset(); common_comment=NULL; in_typedef=0; ;
    break;}
case 6:
{ scope=0; reset(); common_comment=NULL; in_typedef=0; ;
    break;}
case 9:
{ scope=0; reset(); common_comment=NULL; in_typedef=0; ;
    break;}
case 10:
{ scope=0; reset(); common_comment=NULL; in_typedef=0;
                  yyval=yyvsp[0]; ;
    break;}
case 11:
{ in_type_spec=0; ;
    break;}
case 12:
{ in_type_spec=0; ;
    break;}
case 13:
{ if(!in_typedef && !in_function) {common_comment=CopyString(GetCurrentComment()); SetCurrentComment(common_comment);} ;
    break;}
case 15:
{ if(yyvsp[-1]) yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); else yyval=yyvsp[0]; ;
    break;}
case 16:
{ if(!current->type) current->type=yyvsp[0]; ;
    break;}
case 17:
{ if(!current->type) current->type=yyvsp[-1];
                  yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 19:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 21:
{ in_type_spec=1; ;
    break;}
case 23:
{
                 if((in_function==0 || in_function==3) && !in_funcdef && !in_structunion)
                   {
                    char* specific_comment=GetCurrentComment();
                    if(!common_comment)   SetCurrentComment(specific_comment); else
                    if(!specific_comment) SetCurrentComment(common_comment);   else
                    if(strcmp(common_comment,specific_comment)) SetCurrentComment(ConcatStrings(3,common_comment," ",specific_comment)); else
                                          SetCurrentComment(common_comment);
                   }

                 if(in_typedef)
                   {
                    char* vname=strstr(yyvsp[0],current->name);
                    SeenTypedefName(current->name,vname[strlen(current->name)]=='('?-1:1);
                    if(!in_header)
                       SeenTypedef(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]));
                    if(in_function==3)
                       DownScope();
                   }
                 else
                    if(in_function==2)
                       SeenFunctionArg(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]));
                    else
                      {
                       char* vname=strstr(yyvsp[0],current->name);
                       if(vname[strlen(current->name)]!='(' && IsATypeName(current->type)!='f')
                         {
                          if((in_funcbody==0 || scope&EXTERN_F) && !in_structunion && !(in_header==GLOBAL && scope&EXTERN_H))
                             SeenVariableDefinition(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]),SCOPE);
                          else
                             if(in_funcbody)
                                SeenScopeVariable(current->name);
                         }
                       else
                         {
                          SeenFunctionProto(current->name,in_funcbody);
                          if(in_function==3)
                             DownScope();
                         }
                      }

                 if(in_function==3) in_function=0;
                ;
    break;}
case 36:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 38:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]);
                  { int i=0; while(yyvsp[-1][i] && yyvsp[-1][i]=='*') i++; if(!yyvsp[-1][i]) in_type_spec=0; } ;
    break;}
case 39:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 40:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 41:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 42:
{ yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 43:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 44:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 45:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 46:
{ yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 47:
{ in_type_spec=0; ;
    break;}
case 48:
{ in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 50:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 51:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 52:
{ yyval=ConcatStrings(4,yyvsp[-2]," ",yyvsp[-1],yyvsp[0]); ;
    break;}
case 54:
{ if(yyvsp[-1][0]=='*' && yyvsp[-1][1]==' ') { yyvsp[-1]=&yyvsp[-1][1]; yyvsp[-1][0]='*'; }
                  yyval=ConcatStrings(4," ",yyvsp[-2],yyvsp[-1],yyvsp[0]);
                ;
    break;}
case 57:
{ yyval=ConcatStrings(2," ",yyvsp[0]); current->name=yyvsp[0];
                  if(!current->type) current->type="int";
                  if(in_funcdef==1 && in_function!=3 && !in_structunion) SeenScopeVariable(yyvsp[0]); ;
    break;}
case 58:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 59:
{ in_type_spec=0; ;
    break;}
case 60:
{ in_type_spec=1; ;
    break;}
case 61:
{ yyval=ConcatStrings(4,yyvsp[-5],yyvsp[-4],yyvsp[-2],yyvsp[0]); ;
    break;}
case 63:
{ yyval=NULL; ;
    break;}
case 64:
{ yyval=NULL;
                  if(in_funcbody) scope|=EXTERN_F;
                  else if(in_header) scope|=EXTERN_H;
                  else scope|=EXTERNAL; ;
    break;}
case 65:
{ yyval=NULL; ;
    break;}
case 66:
{ yyval=NULL; scope |= LOCAL; ;
    break;}
case 67:
{ yyval=NULL;
                  in_typedef=1; if(!in_header) SeenTypedef(NULL,NULL);
                  common_comment=CopyString(GetCurrentComment()); ;
    break;}
case 68:
{ yyval=NULL; scope |= INLINED; ;
    break;}
case 70:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 71:
{ if(!current->type) current->qual=ConcatStrings(3,current->qual,yyvsp[0]," "); ;
    break;}
case 72:
{ if(!current->type) current->qual=ConcatStrings(3,current->qual,yyvsp[0]," "); ;
    break;}
case 73:
{ in_type_spec=1; ;
    break;}
case 83:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 84:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 86:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 87:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 96:
{ in_type_spec=0; ;
    break;}
case 97:
{ in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 100:
{ push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; ;
    break;}
case 101:
{ pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); ;
    break;}
case 102:
{ push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; ;
    break;}
case 103:
{ pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]);;
    break;}
case 107:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 108:
{ if(!in_header) SeenStructUnionComp(yyvsp[0],in_structunion); ;
    break;}
case 109:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); if(!in_header) SeenStructUnionComp(yyvsp[-2],in_structunion); ;
    break;}
case 111:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 116:
{ push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; ;
    break;}
case 117:
{ pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); ;
    break;}
case 118:
{ push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; ;
    break;}
case 119:
{ pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]);;
    break;}
case 120:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 125:
{ push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; ;
    break;}
case 126:
{ pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); ;
    break;}
case 127:
{ push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; ;
    break;}
case 128:
{ pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]);;
    break;}
case 129:
{ yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 135:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 136:
{ yyval = ConcatStrings(3, yyvsp[-1], " ", yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(yyvsp[-1],in_structunion); ;
    break;}
case 137:
{ yyval = ConcatStrings(3, yyvsp[-1], " ", yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(yyvsp[-1],in_structunion); ;
    break;}
case 139:
{ comp_type=yyvsp[0]; ;
    break;}
case 140:
{ yyval=ConcatStrings(3,yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; ;
    break;}
case 141:
{ comp_type=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 142:
{ yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; ;
    break;}
case 143:
{ comp_type=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); ;
    break;}
case 144:
{ yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; ;
    break;}
case 145:
{ if(!in_header) SeenStructUnionComp(ConcatStrings(2,comp_type,yyvsp[0]),in_structunion); ;
    break;}
case 146:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(ConcatStrings(2,comp_type,yyvsp[0]),in_structunion); ;
    break;}
case 149:
{ if(in_function==2) { DownScope(); pop(); in_function=0; } ;
    break;}
case 150:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 151:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 155:
{ pop(); in_funcbody=1; in_function=0; ;
    break;}
case 156:
{ in_funcbody=in_function=0; DownScope(); SeenFunctionDefinition(NULL); ;
    break;}
case 157:
{ char *func_type,*fname=strstr(yyvsp[0],(current-1)->name),*parenth=strstr(yyvsp[0],"(");
                  if(parenth>fname)
                     {parenth[0]=0;func_type=ConcatStrings(3,(current-1)->qual,(current-1)->type,yyvsp[0]);}
                  else
                    {
                     int open=1;
                     char *argbeg=strstr(&parenth[1],"("),*argend;
                     argbeg[1]=0;
                     for(argend=argbeg+2;*argend;argend++)
                       {
                        if(*argend=='(') open++;
                        if(*argend==')') open--;
                        if(!open) break;
                       }
                     func_type=ConcatStrings(4,(current-1)->qual,(current-1)->type,yyvsp[0],argend);
                    }
                  SeenFunctionDefinition(func_type);
                ;
    break;}
case 159:
{ yyval=ConcatStrings(3,current->qual,current->type,yyvsp[0]); ;
    break;}
case 161:
{ yyval=ConcatStrings(3,current->qual,current->type,yyvsp[-1]); ;
    break;}
case 162:
{ push(); in_function=2; ;
    break;}
case 164:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 165:
{ push(); if(in_function==0) UpScope();
                  if(in_function==0 && !in_funcdef) in_function=1; if(in_function!=3) in_funcdef++; ;
    break;}
case 166:
{ pop();  if(in_function!=3) in_funcdef--; if(in_funcdef==0) in_function=3;
                  yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); ;
    break;}
case 167:
{
                  if(!in_funcdef && !in_function && !in_funcbody) SeenFunctionDeclaration(current->name,SCOPE);
                  in_type_spec=0;
                ;
    break;}
case 168:
{ if(in_function==1 && in_funcdef==1) SeenFunctionArg("void","void");
                  if(in_structunion) yyval=NULL; else yyval="void"; ;
    break;}
case 171:
{ if(in_function==1 && in_funcdef==1 && in_funcbody==0) { SeenFunctionArg(yyvsp[0],NULL); SeenScopeVariable(yyvsp[0]); } ;
    break;}
case 172:
{ if(in_function==1 && in_funcdef==1 && in_funcbody==0) { SeenFunctionArg(yyvsp[0],NULL); SeenScopeVariable(yyvsp[0]); }
                  yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 174:
{ if(in_function==1 && in_funcdef==1 && in_funcbody==0) SeenFunctionArg(yyvsp[0],yyvsp[0]);
                  yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 175:
{ if(in_function==1 && in_funcdef==1 && in_funcbody==0) SeenFunctionArg(strcmp("void",yyvsp[0])?current->name:"void",yyvsp[0]);
                  in_type_spec=0; ;
    break;}
case 176:
{ if(in_function==1 && in_funcdef==1 && in_funcbody==0) SeenFunctionArg(current->name,yyvsp[0]);
                  in_type_spec=0; yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 177:
{ in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 178:
{ in_type_spec=0; ;
    break;}
case 179:
{ in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 194:
{ UpScope(); reset(); ;
    break;}
case 195:
{ DownScope(); ;
    break;}
case 236:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 253:
{ yyval=ConcatStrings(5,yyvsp[-4],yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 254:
{ yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 256:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 258:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 260:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 262:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 264:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 266:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 270:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 276:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 280:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 284:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 300:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 301:
{ yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 305:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 308:
{ yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 309:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 310:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 311:
{ yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); ;
    break;}
case 314:
{ if(!IsAScopeVariable(yyvsp[0])) SeenFunctionCall(yyvsp[0]); ;
    break;}
case 330:
{ CheckFunctionVariableRef(yyvsp[0],in_funcbody); ;
    break;}
case 336:
{ yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); ;
    break;}
case 337:
{ push(); ;
    break;}
case 338:
{ pop(); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}


#if YYDEBUG

static int   last_yylex[11];
static char *last_yylval[11];
static int count=0,modcount=0;

#endif /* YYDEBUG */


 /*++++++++++++++++++++++++++++++++++++++
  Stop parsing the current file, due to an error.

  char *s The error message to print out.
  ++++++++++++++++++++++++++++++++++++++*/

static void yyerror( char *s )
{
#if YYDEBUG
 int i;
#endif

 fflush(stdout);
 fprintf(stderr,"%s:%d: cxref: %s\n\n",parse_file,parse_line,s);

#if YYDEBUG

 fprintf(stderr,"The previous 10, current and next 10 symbols are:\n");

 for(i=count>10?count-11:0,modcount=i%11;i<count-1;i++,modcount=i%11)
#ifdef YYBISON
    fprintf(stderr,"%3d | %3d : %16s : %s\n",i+1-count,last_yylex[modcount],last_yylex[modcount]>255?yytname[last_yylex[modcount]-255]:"",last_yylval[modcount]);
#else
    fprintf(stderr,"%3d | %3d : %s\n",i+1-count,last_yylex[modcount],last_yylval[modcount]);
#endif

#ifdef YYBISON
 fprintf(stderr,"  0 | %3d : %16s : %s\n",yychar,yychar>255?yytname[yychar-255]:"",yylval);
#else
 fprintf(stderr,"  0 | %3d : %s\n",yychar,yylval);
#endif

 for(i=0;i<10;i++)
   {
    yychar=yylex();
    if(!yychar)
      {fprintf(stderr,"END OF FILE\n");break;}
#ifdef YYBISON
    fprintf(stderr,"%3d | %3d : %16s : %s\n",i+1,yychar,yychar>255?yytname[yychar-255]:"",yylval);
#else
    fprintf(stderr,"%3d | %3d : %s\n",i+1,yychar,yylval);
#endif
   }

 fprintf(stderr,"\n");

#endif /* YYDEBUG */

 /* Finish off the input. */

#undef yylex

 if(yychar)
    while((yychar=yylex()));
}


 /*++++++++++++++++++++++++++++++++++++++
  Call the lexer, the feedback from the parser to the lexer is applied here.

  int cxref_yylex Returns the value from the lexer, modified due to parser feedback.
  ++++++++++++++++++++++++++++++++++++++*/

static int cxref_yylex(void)
{
 static int last_yyl=0;
 int yyl=yylex();

 if(yyl==TYPE_NAME)
    if(in_type_spec || last_yyl==TYPE_NAME ||
       last_yyl==CHAR || last_yyl==SHORT || last_yyl==INT || last_yyl==LONG ||
       last_yyl==SIGNED || last_yyl==UNSIGNED ||
       last_yyl==FLOAT || last_yyl==DOUBLE)
       yyl=IDENTIFIER;

 last_yyl=yyl;

#if YYDEBUG

 last_yylex [modcount]=yyl;
 last_yylval[modcount]=yylval;

 if(yyl)
   {
    count++;
    modcount=count%11;
   }
 else
   {
    count=0;
    modcount=0;
   }

#if YYDEBUG == 2

 if(yyl)
#ifdef YYBISON
    printf("#parse.y# %6d | %16s:%4d | %3d : %16s : %s\n",count,parse_file,parse_line,yyl,yyl>255?yytname[yyl-255]:"",yylval);
#else
    printf("#parse.y# %6d | %16s:%4d | %3d : %s\n",count,parse_file,parse_line,yyl,yylval);
#endif /* YYBISON */
 else
    printf("#parse.y# %6d | %16s:%4d | END OF FILE\n",count,parse_file,parse_line);

 fflush(stdout);

#endif /* YYDEBUG==2 */

#endif /* YYDEBUG */

 return(yyl);
}
